_G=GLOBAL
require = _G.require
local EQUIPSLOTS=_G.EQUIPSLOTS

local IsDST = GLOBAL.TheSim:GetGameID() == "DST"
local IsServer = not IsDST or GLOBAL.TheNet:GetIsServer()

local function canaddeqslot()
	for k,v in pairs(EQUIPSLOTS) do
		if v then
			local _,n1 = string.find(v,'ack') --back
			--local _,n2 = string.find(v,'eck') --neck
			if n1 then --or n2 then
				return false
			end
		end
	end
	return EQUIPSLOTS.BPAM == nil
end	
if not canaddeqslot() then return end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
local ITEMSLOTS = GetModConfigData("ITEMSLOTS") or 0
_G.MAXITEMSLOTS = IsDST and (_G.MAXITEMSLOTS or 15) + ITEMSLOTS --dst change inventory size

Assets =
{
	Asset("IMAGE", "images/bpam.tex"),
	Asset("ATLAS", "images/bpam.xml"),
}

local function Pf_PI_A(inst) --dst Server  ds
	if EQUIPSLOTS.BPAM == nil
		or not inst
		or not inst.components
		or not inst.components.equippable then return end
	if inst.components.equippable.equipslot == EQUIPSLOTS.BODY 
		and( inst.components.container or inst.components.armor) then
		inst.components.equippable.equipslot = EQUIPSLOTS.BPAM
	end
end
local function InvBar_PC(self)--dst ds
		if EQUIPSLOTS.BPAM == nil or self.bpamslot ~= nil then return end
		self.bpamslot = true
		
		self:AddEquipSlot(EQUIPSLOTS.BPAM, "images/bpam.xml", "bpam.tex")
	
	local function bgc()
		local a = ITEMSLOTS*1.25
		local b = #self.equipslotinfo
		local c = IsDST and 1.25 or 0
		local abc = (a+b+c)*0.05
		self.bg:SetScale(1+abc,1,1)
		self.bgcover:SetScale(1+abc,1,1)
	end
	
	local OldRebuild = self.Rebuild
	function self:Rebuild(...)
		OldRebuild(self,...)
		bgc()
	end
end
local function Hud_PC(self) --ds
	if EQUIPSLOTS.BPAM == nil then return end
	local OldFn = self.SetMainCharacter
	function self:SetMainCharacter(maincharacter,...)
		OldFn(self, maincharacter,...)
		if not(self.controls and self.controls.inv) then return end
		
		local pack =maincharacter.components.inventory:GetEquippedItem(EQUIPSLOTS.BPAM) 
		if pack and pack.components.container then
			pack.components.container:Close()
			pack.components.container:Open(maincharacter)
		end	
	end
end

EQUIPSLOTS.BPAM = 'bpam'
AddClassPostConstruct("widgets/inventorybar", InvBar_PC)

if IsServer then
	AddPrefabPostInitAny(Pf_PI_A)
end
if not IsDST then
	AddClassPostConstruct("screens/playerhud", Hud_PC)
	AddComponentPostInit("inventory",function(self,inst) --ds change inventory size
		self.maxslots = (self.maxslots or 15) + ITEMSLOTS
	end)
else
	AddComponentPostInit("inventory", function(self,inst) --dst get overflow
		local OldEquip = self.Equip
		self.Equip = function(self,item,old_to_active,...)
			if OldEquip(self,item,old_to_active,...) and item and item.components and item.components.equippable then
				local eslot = item.components.equippable.equipslot
				if self.equipslots[eslot] ~= item then
					if eslot == GLOBAL.EQUIPSLOTS.BPAM and item.components.container ~= nil then
						self.inst:PushEvent("setoverflow", { overflow = item })
					end
				end
				return true
			else
				return
			end
		end	
		self.GetOverflowContainer = function()
			if self.ignoreoverflow then return end
			local item = self:GetEquippedItem(EQUIPSLOTS.BPAM)
			return item ~= nil and item.components.container or nil
		end
	end)
			AddPrefabPostInit("inventory_classified", function(inst)
				if not IsServer then
				local function GetOverflowContainer(inst)
					local item = inst.GetEquippedItem(inst,EQUIPSLOTS.BPAM)
					return item ~= nil and item.replica.container or nil
				end
				
				local OldFn = inst.Has
				local function Has(inst, prefab, amount,...)
					local _,count = OldFn(inst,prefab,amount,...)
					local overflow = GetOverflowContainer(inst)
					if overflow ~= nil then
						local overflowhas, overflowcount = overflow:Has(prefab, amount)
						count = count + overflowcount
					end
					return count >= amount, count		
				end
				
					inst.GetOverflowContainer = GetOverflowContainer
					inst.Has = Has
				end
			end)
end